import copy
import os
import unittest

from integration.integration_test_utils import IntegrationTestUtils


class TestDeposition(unittest.TestCase):

    def setUp(self) -> None:
        super().setUp()
        default_config = '../test_data/test_deployment/regions/EastAfrica/resources/coordinator/configs/config_EastAfrica_fc_live.json'
        self.default_config_dict: dict = IntegrationTestUtils.load_json_file(default_config)
        i = 0

    def test_depo_standard_inputs_expected_results1(self):

        nowstring: str = IntegrationTestUtils.get_now_string()

        os.environ["EMAIL_CRED"] = "../test_data/test_deployment/envs/Cred_gmail.json"
        from Processor import run_Process, set_log_level
        args_dict: dict = {}
        args_dict['component'] = 'Deposition'
        args_dict['config_paths'] = [IntegrationTestUtils.TEMP_CONFIG_FILE_PATH]
        args_dict['log_level'] = 'error'
        args_dict['live'] = False
        args_dict['start_date'] = '20221001'
        args_dict['noupload'] = True
        set_log_level(args_dict['log_level'])

        run_dict: dict = copy.deepcopy(self.default_config_dict)
        test_out_path = run_dict['WorkspacePathout'] + nowstring + os.sep
        run_dict['WorkspacePathout'] = test_out_path
        run_dict['WorkspacePath'] = test_out_path
        run_dict['ServerName'] = ''  # nothing, as local machine
        full_server_path = os.path.abspath("../test_data/met_office/depo/")
        run_dict['Deposition']['ServerPathTemplate'] = full_server_path

        run_dict['SubRegionNames'].remove('Kenya')
        run_dict['Deposition']['EWS-Plotting'].pop('Kenya', None)
        IntegrationTestUtils.write_json_file(run_dict, IntegrationTestUtils.TEMP_CONFIG_FILE_PATH)

        run_Process(args_dict)
        self.assertTrue(True)


if __name__ == '__main__':
    unittest.main()
